# ncurses 6.0 - patch 20170902 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.0 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.0 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.0
#	http://invisible-mirror.net/archives/ncurses/6.0 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.0/ncurses-6.0-20170902.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sat Sep  2 22:52:02 UTC 2017
# ------------------------------------------------------------------------------
# NEWS                             |    9 ++++++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# ncurses/tty/tty_update.c         |    4 ++--
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# progs/dump_entry.c               |   21 +++++++++++----------
# progs/tput.c                     |    4 ++--
# 12 files changed, 36 insertions(+), 28 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2937 
--- ncurses-6.0-20170827+/NEWS	2017-08-27 18:35:58.000000000 +0000
+++ ncurses-6.0-20170902/NEWS	2017-09-02 21:48:17.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2937 2017/08/27 18:35:58 tom Exp $
+-- $Id: NEWS,v 1.2939 2017/09/02 21:48:17 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,13 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20170902
+	+ amend change for endwin-state for better consistency with the older
+	  logic (report/patch by Jeb Rosen, cf: 20170722).
+	+ modify check in fmt_entry() to handle a cancelled reset string
+	  (Debian #873746).  Make similar fixes in other parts of dump_entry.c
+	  and tput.c
+
 20170827
 	+ fix a bug in repeat_char logic (cf: 20170729, report by Chris Clayton).
 
Index: VERSION
--- ncurses-6.0-20170827+/VERSION	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/VERSION	2017-08-29 22:24:15.000000000 +0000
@@ -1 +1 @@
-5:0:9	6.0	20170827
+5:0:9	6.0	20170902
Index: dist.mk
Prereq:  1.1180 
--- ncurses-6.0-20170827+/dist.mk	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/dist.mk	2017-08-29 22:24:15.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1180 2017/08/27 15:37:47 tom Exp $
+# $Id: dist.mk,v 1.1181 2017/08/29 22:24:15 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 0
-NCURSES_PATCH = 20170827
+NCURSES_PATCH = 20170902
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/tty/tty_update.c
Prereq:  1.296 
--- ncurses-6.0-20170827+/ncurses/tty/tty_update.c	2017-08-27 19:40:17.000000000 +0000
+++ ncurses-6.0-20170902/ncurses/tty/tty_update.c	2017-09-02 21:45:44.000000000 +0000
@@ -84,7 +84,7 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: tty_update.c,v 1.296 2017/08/27 19:40:17 tom Exp $")
+MODULE_ID("$Id: tty_update.c,v 1.297 2017/09/02 21:45:44 Jeb.Rosen Exp $")
 
 /*
  * This define controls the line-breakout optimization.  Every once in a
@@ -831,7 +831,7 @@
 	SP_PARM->_fifohold--;
 
 #if USE_SIZECHANGE
-    if ((SP_PARM->_endwin == ewRunning)
+    if ((SP_PARM->_endwin == ewSuspend)
 	|| _nc_handle_sigwinch(SP_PARM)) {
 	/*
 	 * This is a transparent extension:  XSI does not address it,
Index: package/debian-mingw/changelog
--- ncurses-6.0-20170827+/package/debian-mingw/changelog	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/debian-mingw/changelog	2017-08-29 22:24:15.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170827) unstable; urgency=low
+ncurses6 (6.0+20170902) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 29 Aug 2017 18:24:15 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.0-20170827+/package/debian-mingw64/changelog	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/debian-mingw64/changelog	2017-08-29 22:24:15.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170827) unstable; urgency=low
+ncurses6 (6.0+20170902) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 29 Aug 2017 18:24:15 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.0-20170827+/package/debian/changelog	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/debian/changelog	2017-08-29 22:24:15.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170827) unstable; urgency=low
+ncurses6 (6.0+20170902) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 29 Aug 2017 18:24:15 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.228 
--- ncurses-6.0-20170827+/package/mingw-ncurses.nsi	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/mingw-ncurses.nsi	2017-08-29 22:24:15.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.228 2017/08/27 15:37:47 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.229 2017/08/29 22:24:15 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "0"
 !define VERSION_YYYY  "2017"
-!define VERSION_MMDD  "0827"
+!define VERSION_MMDD  "0902"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.0-20170827+/package/mingw-ncurses.spec	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/mingw-ncurses.spec	2017-08-29 22:24:15.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.0
-Release: 20170827
+Release: 20170902
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.0-20170827+/package/ncurses.spec	2017-08-27 15:37:47.000000000 +0000
+++ ncurses-6.0-20170902/package/ncurses.spec	2017-08-29 22:24:15.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.0
-Release: 20170827
+Release: 20170902
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: progs/dump_entry.c
Prereq:  1.167 
--- ncurses-6.0-20170827+/progs/dump_entry.c	2017-07-15 21:22:01.000000000 +0000
+++ ncurses-6.0-20170902/progs/dump_entry.c	2017-09-02 21:01:54.000000000 +0000
@@ -39,7 +39,7 @@
 #include "termsort.c"		/* this C file is generated */
 #include <parametrized.h>	/* so is this */
 
-MODULE_ID("$Id: dump_entry.c,v 1.167 2017/07/15 21:22:01 tom Exp $")
+MODULE_ID("$Id: dump_entry.c,v 1.168 2017/09/02 21:01:54 tom Exp $")
 
 #define DISCARD(string) string = ABSENT_STRING
 #define PRINTF (void) printf
@@ -987,12 +987,12 @@
 #undef CUR
 #define CUR tterm->
     if (outform == F_TERMCAP) {
-	if (termcap_reset != ABSENT_STRING) {
-	    if (init_3string != ABSENT_STRING
+	if (VALID_STRING(termcap_reset)) {
+	    if (VALID_STRING(init_3string)
 		&& !strcmp(init_3string, termcap_reset))
 		DISCARD(init_3string);
 
-	    if (reset_2string != ABSENT_STRING
+	    if (VALID_STRING(reset_2string)
 		&& !strcmp(reset_2string, termcap_reset))
 		DISCARD(reset_2string);
 	}
@@ -1068,7 +1068,7 @@
 	buffer[0] = '\0';
 
 	if (predval != FAIL) {
-	    if (capability != ABSENT_STRING
+	    if (VALID_STRING(capability)
 		&& i + 1 > num_strings)
 		num_strings = i + 1;
 
@@ -1148,8 +1148,7 @@
 	    }
 	}
 	/* e.g., trimmed_sgr0 */
-	if (capability != ABSENT_STRING &&
-	    capability != CANCELLED_STRING &&
+	if (VALID_STRING(capability) &&
 	    capability != tterm->Strings[i])
 	    free(capability);
     }
@@ -1320,7 +1319,8 @@
 
     for (n = 0; n <= 10; ++n) {
 	_nc_SPRINTF(name, _nc_SLIMIT(sizeof(name)) "lf%d", n);
-	if ((cap = find_string(tterm, name)) != ABSENT_STRING
+	cap = find_string(tterm, name);
+	if (VALID_STRING(cap)
 	    && kill_string(tterm, cap)) {
 	    target -= (int) (strlen(cap) + 5);
 	    ++result;
@@ -1345,7 +1345,8 @@
 
     for (n = 60; n >= 0; --n) {
 	_nc_SPRINTF(name, _nc_SLIMIT(sizeof(name)) "kf%d", n);
-	if ((cap = find_string(tterm, name)) != ABSENT_STRING
+	cap = find_string(tterm, name);
+	if (VALID_STRING(cap)
 	    && kill_string(tterm, cap)) {
 	    target -= (int) (strlen(cap) + 5);
 	    ++result;
@@ -1367,7 +1368,7 @@
 {
     bool result = TRUE;
 
-    if (mapping != ABSENT_STRING) {
+    if (VALID_STRING(mapping)) {
 	int n = 0;
 	while (mapping[n] != '\0') {
 	    if (isLine(mapping[n]) &&
Index: progs/tput.c
Prereq:  1.71 
--- ncurses-6.0-20170827+/progs/tput.c	2017-08-19 13:44:27.000000000 +0000
+++ ncurses-6.0-20170902/progs/tput.c	2017-09-02 21:03:26.000000000 +0000
@@ -50,7 +50,7 @@
 #include <transform.h>
 #include <tty_settings.h>
 
-MODULE_ID("$Id: tput.c,v 1.71 2017/08/19 13:44:27 tom Exp $")
+MODULE_ID("$Id: tput.c,v 1.72 2017/09/02 21:03:26 tom Exp $")
 
 #define PUTS(s)		fputs(s, stdout)
 
@@ -214,7 +214,7 @@
 	}
 #endif
 	quit(4, "unknown terminfo capability '%s'", name);
-    } else if (s != ABSENT_STRING) {
+    } else if (VALID_STRING(s)) {
 	if (argc > 1) {
 	    int k;
 	    int ignored;
